## boost1.83 1.83.0

=== CMakeLists.txt ===
# Copyright 2019, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

# The default build type must be set before project()
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR AND NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

project(Boost VERSION 1.83.0 LANGUAGES CXX)

set(BOOST_SUPERPROJECT_VERSION ${PROJECT_VERSION})
set(BOOST_SUPERPROJECT_SOURCE_DIR ${PROJECT_SOURCE_DIR})

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/tools/cmake/include)

include(BoostRoot)

=== libs/beast/CMakeLists.txt ===
if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

# Generated by `boostdep --cmake beast`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_beast VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_beast INTERFACE)
add_library(Boost::beast ALIAS boost_beast)

target_include_directories(boost_beast INTERFACE include)

target_link_libraries(boost_beast
  INTERFACE
    Boost::asio
    Boost::assert
    Boost::bind
    Boost::config
    Boost::container
    Boost::core
    Boost::endian
    Boost::intrusive
    Boost::logic
    Boost::mp11
    Boost::optional
    Boost::smart_ptr
    Boost::static_assert
    Boost::static_string
    Boost::system
    Boost::throw_exception
    Boost::type_traits
    Boost::utility
    Boost::winapi
)

target_compile_features(boost_beast INTERFACE cxx_std_11)

else()

#
# Copyright (c) 2016-2017 Vinnie Falco (vinnie dot falco at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/beast
#

cmake_minimum_required (VERSION 3.5.1)

if (POLICY CMP0074)
    cmake_policy (SET CMP0074 NEW)
endif()

#-------------------------------------------------------------------------------

function (DoGroupSources curdir rootdir folder)
    file (GLOB children RELATIVE ${PROJECT_SOURCE_DIR}/${curdir} ${PROJECT_SOURCE_DIR}/${curdir}/*)
    foreach (child ${children})
        if (IS_DIRECTORY ${PROJECT_SOURCE_DIR}/${curdir}/${child})
            DoGroupSources (${curdir}/${child} ${rootdir} ${folder})
        elseif (${child} STREQUAL "CMakeLists.txt")
            source_group("" FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        else()
            string (REGEX REPLACE ^${rootdir} ${folder} groupname ${curdir})
            string (REPLACE "/" "\\" groupname ${groupname})
            source_group (${groupname} FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        endif()
    endforeach()
endfunction()

function (GroupSources curdir folder)
    DoGroupSources (${curdir} ${curdir} ${folder})
endfunction()

#-------------------------------------------------------------------------------
#
# Beast
#
#-------------------------------------------------------------------------------

project (Beast VERSION 347)

set_property (GLOBAL PROPERTY USE_FOLDERS ON)
option (Beast_BUILD_EXAMPLES "Build examples" ON)
option (Beast_BUILD_TESTS "Build tests" ON)
option (Beast_ENABLE_HANDLER_TRACKING "Define BOOST_ASIO_ENABLE_HANDLER_TRACKING when building libraries" OFF)
option (Boost_USE_STATIC_LIBS "Use Static Boost libraries" ON)

if (MSVC)
    set (CMAKE_VERBOSE_MAKEFILE FALSE)

    add_definitions (
        -D_WIN32_WINNT=0x0601
        -D_SCL_SECURE_NO_WARNINGS=1
        -D_CRT_SECURE_NO_WARNINGS=1
        -D_SILENCE_CXX17_ALLOCATOR_VOID_DEPRECATION_WARNING
        -D_SILENCE_CXX17_ADAPTOR_TYPEDEFS_DEPRECATION_WARNING
    )

    add_compile_options(
        /bigobj       # large object file format
        /permissive-  # strict C++
        #/wd4503      # decorated name length exceeded, name was truncated
        /W4           # enable all warnings
        /MP           # Multi-processor compilation
        )

    set (Boost_USE_STATIC_RUNTIME ON)

    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Ob2 /Oi /Ot /GL /MT")
    set (CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Oi /Ot /MT")

    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
    set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    # for RelWithDebInfo builds, disable incremental linking
    # since CMake sets it ON by default for that build type and it
    # causes warnings
    #
    string (REPLACE "/INCREMENTAL" "/INCREMENTAL:NO" replacement_flags
        ${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO})
    set (CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO ${replacement_flags})

else()
    set (THREADS_PREFER_PTHREAD_FLAG ON)
    find_package (Threads)
    link_libraries(Threads::Threads)


    set( CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -Wpedantic -Wno-unused-parameter")

    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wrange-loop-analysis")
    endif ()
endif()

# Must come before Boost includes, otherwise the
# IDE sees the wrong file due to boost/ symlinks.
include_directories (include)

#-------------------------------------------------------------------------------
#
# OpenSSL
#
#-------------------------------------------------------------------------------

if (APPLE AND NOT DEFINED ENV{OPENSSL_ROOT_DIR})
  find_program(HOMEBREW brew)
  if (NOT HOMEBREW STREQUAL "HOMEBREW-NOTFOUND")
    execute_process(COMMAND brew --prefix openssl
      OUTPUT_VARIABLE OPENSSL_ROOT_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()

find_package(OpenSSL)
if (NOT MSVC)
    link_libraries(${OPENSSL_LIBRARIES})
endif()

#-------------------------------------------------------------------------------
#
# Boost
#
#-------------------------------------------------------------------------------

get_filename_component (BOOST_ROOT ../../ ABSOLUTE)

# VFALCO I want static but "b2 stage" builds a minimal set which excludes static
add_definitions (-DBOOST_ALL_STATIC_LINK=1)

add_definitions (-DBOOST_ASIO_NO_DEPRECATED=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_ARRAY=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_BIND=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_DATE_TIME=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_REGEX=1)
add_definitions (-DBOOST_COROUTINES_NO_DEPRECATION_WARNING=1)

if (MSVC)
    include_directories (${BOOST_ROOT})
    link_libraries( bcrypt.lib )
else()
    set(BOOST_INCLUDEDIR ${BOOST_ROOT})
    set(BOOST_LIBRARYDIR ${BOOST_ROOT}/stage/lib)
    find_package(Boost COMPONENTS context filesystem system thread REQUIRED)
    link_libraries(Boost::context Boost::filesystem Boost::system Boost::thread)
endif()

link_directories(${BOOST_ROOT}/stage/lib)

if (MINGW)
    link_libraries(ws2_32 mswsock)
endif()

#-------------------------------------------------------------------------------

if ("${VARIANT}" STREQUAL "coverage")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE DEBUG)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2 --coverage")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
    endif()

elseif ("${VARIANT}" STREQUAL "ubasan")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE RELWITHDEBINFO)
        set (CMAKE_CXX_FLAGS
          "${CMAKE_CXX_FLAGS} -DBOOST_BEAST_NO_SLOW_TESTS=1 -msse4.2 -funsigned-char -fno-omit-frame-pointer -fsanitize=address,undefined -fno-sanitize-recover=address,undefined -fsanitize-blacklist=${PROJECT_SOURCE_DIR}/tools/blacklist.supp")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address,undefined -fno-sanitize-recover=address,undefined")
    endif()

elseif ("${VARIANT}" STREQUAL "debug")
    set (CMAKE_BUILD_TYPE DEBUG)

elseif ("${VARIANT}" STREQUAL "release")
    set (CMAKE_BUILD_TYPE RELEASE)

endif()

#-------------------------------------------------------------------------------
#
# Static Libraries
#
#-------------------------------------------------------------------------------

add_definitions (-DBOOST_ASIO_SEPARATE_COMPILATION=1)
add_definitions (-DBOOST_BEAST_SEPARATE_COMPILATION=1)

GroupSources (test "/")

add_library (
    lib-asio STATIC
    test/lib_asio.cpp
)
if(Beast_ENABLE_HANDLER_TRACKING)
    target_compile_definitions(lib-asio
        PUBLIC BOOST_ASIO_ENABLE_HANDLER_TRACKING=1)
endif()

set_property(TARGET lib-asio PROPERTY FOLDER "static-libs")

add_library (
    lib-asio-ssl STATIC
    test/lib_asio_ssl.cpp
)

set_property(TARGET lib-asio-ssl PROPERTY FOLDER "static-libs")

add_library (
    lib-beast STATIC
    test/lib_beast.cpp
)

set_property(TARGET lib-beast PROPERTY FOLDER "static-libs")

target_link_libraries(lib-beast lib-asio)

#-------------------------------------------------------------------------------
#
# Tests and examples
#

include_directories (.)

if (OPENSSL_FOUND)
    include_directories (${OPENSSL_INCLUDE_DIR})
endif()

file (GLOB_RECURSE BOOST_BEAST_FILES
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.hpp
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.ipp
)

file (GLOB_RECURSE BOOST_BEAST_EXPERIMENTAL_FILES
    ${PROJECT_SOURCE_DIR}/include/boost/beast/_experimental/*.hpp
    ${PROJECT_SOURCE_DIR}/include/boost/beast/_experimental/*.ipp
)

file (GLOB_RECURSE COMMON_FILES
    ${PROJECT_SOURCE_DIR}/example/common/*.hpp
  )

if (Beast_BUILD_EXAMPLES AND
    (NOT "${VARIANT}" STREQUAL "coverage") AND
    (NOT "${VARIANT}" STREQUAL "ubasan"))
    add_subdirectory (example)
endif()

if (Beast_BUILD_TESTS)
    add_subdirectory (test)
endif()

endif()

=== libs/endian/CMakeLists.txt ===
# Copyright 2019 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_endian VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_endian INTERFACE)
add_library(Boost::endian ALIAS boost_endian)

target_include_directories(boost_endian INTERFACE include)

target_link_libraries(boost_endian
  INTERFACE
    Boost::config
    Boost::core
    Boost::static_assert
    Boost::type_traits
)

if(BUILD_TESTING)

  add_subdirectory(test)

endif()

=== libs/headers/CMakeLists.txt ===
# Generated by `boostdep --cmake headers`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.20)

project(boost_headers VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_headers INTERFACE)
add_library(Boost::headers ALIAS boost_headers)

target_include_directories(boost_headers INTERFACE include)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/interprocess/CMakeLists.txt ===
# Generated by `boostdep --cmake interprocess`
# Copyright 2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_interprocess VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_interprocess INTERFACE)
add_library(Boost::interprocess ALIAS boost_interprocess)

target_include_directories(boost_interprocess INTERFACE include)

target_link_libraries(boost_interprocess
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container
    Boost::core
    Boost::integer
    Boost::intrusive
    Boost::move
    Boost::static_assert
    Boost::type_traits
    Boost::unordered
    Boost::winapi
)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/iterator/CMakeLists.txt ===
# Copyright 2018 Peter Dimov
# Copyright 2018 Andrey Semashev
# Distributed under the Boost Software License, Version 1.0.
# See accompanying file LICENSE_1_0.txt or copy at https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.20)

project(boost_iterator VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_iterator INTERFACE)
add_library(Boost::iterator ALIAS boost_iterator)

target_include_directories(boost_iterator INTERFACE include)

target_link_libraries(boost_iterator
    INTERFACE
        Boost::assert
        Boost::concept_check
        Boost::config
        Boost::conversion
        Boost::core
        Boost::detail
        Boost::function_types
        Boost::fusion
        Boost::mpl
        Boost::optional
        Boost::smart_ptr
        Boost::static_assert
        Boost::type_traits
        Boost::utility
)

=== libs/leaf/meson_options.txt ===
option('leaf_hpp',type:'boolean',value:false,description:'Unit tests #include <boost/leaf.hpp> instead of individual headers')
option('leaf_boost_examples',type:'boolean',value:false,description:'Builds the Boost examples and Boost Outcome benchmark')
option('leaf_lua_examples',type:'boolean',value:false,description:'Enable or disable downloading of Lua and building the Lua examples')
option('leaf_diagnostics',type:'integer',value:1,description:'BOOST_LEAF_CFG_DIAGNOSTICS value')
option('leaf_embedded',type:'boolean',value:false,description:'Defines BOOST_LEAF_EMBEDDED')
option('leaf_enable_unit_tests',type:'boolean',value:true,description:'Enable the building of unit test programs')
option('leaf_enable_examples',type:'boolean',value:true,description:'Enable the building of example programs')
option('leaf_enable_benchmarks',type:'boolean',value:false,description:'Enable the building of benchmark programs')

=== libs/locale/CMakeLists.txt ===
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.11...3.20)

project(boost_locale VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

# Using glob here is ok as it is only for headers
file(GLOB_RECURSE headers include/*.hpp)

add_library(boost_locale
  src/boost/locale/encoding/codepage.cpp
  src/boost/locale/encoding/iconv_converter.hpp
  src/boost/locale/encoding/uconv_converter.hpp
  src/boost/locale/encoding/wconv_converter.hpp
  src/boost/locale/shared/date_time.cpp
  src/boost/locale/shared/format.cpp
  src/boost/locale/shared/formatting.cpp
  src/boost/locale/shared/generator.cpp
  src/boost/locale/shared/iconv_codecvt.cpp
  src/boost/locale/shared/iconv_codecvt.hpp
  src/boost/locale/shared/ids.cpp
  src/boost/locale/shared/localization_backend.cpp
  src/boost/locale/shared/message.cpp
  src/boost/locale/shared/mo_lambda.cpp
  src/boost/locale/util/codecvt_converter.cpp
  src/boost/locale/util/default_locale.cpp
  src/boost/locale/util/encoding.cpp
  src/boost/locale/util/encoding.hpp
  src/boost/locale/util/foreach_char.hpp
  src/boost/locale/util/info.cpp
  src/boost/locale/util/locale_data.cpp
  src/boost/locale/util/make_std_unique.hpp
  src/boost/locale/util/numeric.hpp
  src/boost/locale/util/timezone.hpp
  ${headers}
)

add_library(Boost::locale ALIAS boost_locale)

target_include_directories(boost_locale PUBLIC include PRIVATE src)
target_compile_features(boost_locale PUBLIC cxx_std_11)

target_link_libraries(boost_locale
  PUBLIC
    Boost::assert
    Boost::config
    Boost::iterator
    Boost::utility
  PRIVATE
    Boost::core
    Boost::predef
    Boost::thread
)

target_compile_definitions(boost_locale
  PUBLIC
    BOOST_LOCALE_NO_LIB
  PRIVATE
    BOOST_LOCALE_SOURCE
    _CRT_SECURE_NO_WARNINGS
    _SCL_SECURE_NO_WARNINGS
)

if(BUILD_SHARED_LIBS)
  target_compile_definitions(boost_locale PUBLIC BOOST_LOCALE_DYN_LINK)
else()
  target_compile_definitions(boost_locale PUBLIC BOOST_LOCALE_STATIC_LINK)
endif()

# Build Options

find_package(ICU COMPONENTS data i18n uc QUIET)
option(BOOST_LOCALE_ENABLE_ICU "Boost.Locale: enable ICU backend" ${ICU_FOUND})

# Workaround for an issue e.g. on FreeBSD where including ICU may change the used libiconv
if(UNIX AND NOT DEFINED Iconv_INCLUDE_DIR AND BOOST_LOCALE_ENABLE_ICU AND EXISTS "${ICU_INCLUDE_DIRS}/iconv.h")
  set(Iconv_INCLUDE_DIR "${ICU_INCLUDE_DIRS}" CACHE PATH "Path to iconv headers")
  find_package(Iconv QUIET)
  if(NOT Iconv_FOUND)
    # Unset and retry below
    unset(Iconv_INCLUDE_DIR CACHE)
    unset(Iconv_LIBRARY CACHE)
    unset(Iconv_IS_BUILT_IN CACHE)
    unset(Iconv_IS_BUILT_IN)
  endif()
endif()

find_package(Iconv QUIET)
option(BOOST_LOCALE_ENABLE_ICONV "Boost.Locale: enable iconv backend" ${Iconv_FOUND})

if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
  set(_default_posix ON)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  include (CheckIncludeFileCXX)
  check_include_file_cxx ("xlocale.h" HAVE_XLOCALE_H)
  set(_default_posix ${HAVE_XLOCALE_H})
else()
  set(_default_posix OFF)
endif()

option(BOOST_LOCALE_ENABLE_POSIX "Boost.Locale: enable POSIX backend" ${_default_posix})
unset(_default_posix)

option(BOOST_LOCALE_ENABLE_STD "Boost.Locale: enable std::locale backend" ON)
option(BOOST_LOCALE_ENABLE_WINAPI "Boost.Locale: enable Windows API backend" ${WIN32})


if(BOOST_LOCALE_ENABLE_ICONV)

  find_package(Iconv REQUIRED)

  target_compile_definitions(boost_locale PRIVATE BOOST_LOCALE_WITH_ICONV=1)
  target_link_libraries(boost_locale PRIVATE Iconv::Iconv)

  target_sources(boost_locale PRIVATE
    src/boost/locale/util/iconv.hpp
  )
endif()

if(BOOST_LOCALE_ENABLE_ICU)

  find_package(ICU COMPONENTS data i18n uc REQUIRED)

  target_compile_definitions(boost_locale PRIVATE BOOST_LOCALE_WITH_ICU=1)
  target_link_libraries(boost_locale PRIVATE ICU::data ICU::i18n ICU::uc)

  target_sources(boost_locale PRIVATE
    src/boost/locale/icu/all_generator.hpp
    src/boost/locale/icu/boundary.cpp
    src/boost/locale/icu/cdata.hpp
    src/boost/locale/icu/codecvt.cpp
    src/boost/locale/icu/codecvt.hpp
    src/boost/locale/icu/collator.cpp
    src/boost/locale/icu/conversion.cpp
    src/boost/locale/icu/date_time.cpp
    src/boost/locale/icu/formatter.cpp
    src/boost/locale/icu/formatter.hpp
    src/boost/locale/icu/formatters_cache.cpp
    src/boost/locale/icu/formatters_cache.hpp
    src/boost/locale/icu/icu_backend.cpp
    src/boost/locale/icu/icu_backend.hpp
    src/boost/locale/icu/icu_util.hpp
    src/boost/locale/icu/numeric.cpp
    src/boost/locale/icu/time_zone.cpp
    src/boost/locale/icu/time_zone.hpp
    src/boost/locale/icu/uconv.hpp
  )

endif()

if(BOOST_LOCALE_ENABLE_STD)

  target_sources(boost_locale PRIVATE
    src/boost/locale/std/all_generator.hpp
    src/boost/locale/std/codecvt.cpp
    src/boost/locale/std/collate.cpp
    src/boost/locale/std/converter.cpp
    src/boost/locale/std/numeric.cpp
    src/boost/locale/std/std_backend.cpp
    src/boost/locale/std/std_backend.hpp
  )

else()

  target_compile_definitions(boost_locale PRIVATE BOOST_LOCALE_NO_STD_BACKEND=1)

endif()

if(BOOST_LOCALE_ENABLE_WINAPI)

  target_sources(boost_locale PRIVATE
    src/boost/locale/win32/all_generator.hpp
    src/boost/locale/win32/api.hpp
    src/boost/locale/win32/collate.cpp
    src/boost/locale/win32/converter.cpp
    src/boost/locale/win32/numeric.cpp
    src/boost/locale/win32/win_backend.cpp
    src/boost/locale/win32/win_backend.hpp
  )

else()

  target_compile_definitions(boost_locale PRIVATE BOOST_LOCALE_NO_WINAPI_BACKEND=1)

endif()

if(BOOST_LOCALE_ENABLE_WINAPI OR (BOOST_LOCALE_ENABLE_STD AND WIN32))

  target_sources(boost_locale PRIVATE
    src/boost/locale/win32/lcid.cpp
    src/boost/locale/win32/lcid.hpp
  )

endif()

if(BOOST_LOCALE_ENABLE_POSIX)

  target_sources(boost_locale PRIVATE
    src/boost/locale/posix/all_generator.hpp
    src/boost/locale/posix/codecvt.cpp
    src/boost/locale/posix/collate.cpp
    src/boost/locale/posix/converter.cpp
    src/boost/locale/posix/numeric.cpp
    src/boost/locale/posix/posix_backend.cpp
    src/boost/locale/posix/posix_backend.hpp
  )

else()

  target_compile_definitions(boost_locale PRIVATE BOOST_LOCALE_NO_POSIX_BACKEND=1)

endif()

if(BOOST_LOCALE_ENABLE_WINAPI OR BOOST_LOCALE_ENABLE_STD OR BOOST_LOCALE_ENABLE_POSIX)

  target_sources(boost_locale PRIVATE
    src/boost/locale/util/gregorian.cpp
    src/boost/locale/util/gregorian.hpp
  )

endif()

get_target_property(sources boost_locale SOURCES)
set(sources_src ${sources})
list(FILTER sources_src INCLUDE REGEX "^src/")
set(sources_inc ${sources})
list(FILTER sources_inc EXCLUDE REGEX "^src/")
source_group(TREE "${CMAKE_CURRENT_SOURCE_DIR}/src/boost/locale" PREFIX "sources" FILES ${sources_src})
source_group(TREE "${CMAKE_CURRENT_SOURCE_DIR}/include/boost/locale" PREFIX "headers" FILES ${sources_inc})
source_group("headers" FILES "include/boost/locale.hpp")

message(STATUS "Boost.Locale: "
  "iconv ${BOOST_LOCALE_ENABLE_ICONV}, "
  "ICU ${BOOST_LOCALE_ENABLE_ICU}, "
  "POSIX ${BOOST_LOCALE_ENABLE_POSIX}, "
  "std ${BOOST_LOCALE_ENABLE_STD}, "
  "winapi ${BOOST_LOCALE_ENABLE_WINAPI}"
)

option(BOOST_LOCALE_WERROR "Treat warnings as errors in Boost.Locale" ${BOOST_LOCALE_WERROR})
if(MSVC)
    set(BOOST_LOCALE_WARNING_OPTIONS /W4)
    if(BOOST_LOCALE_WERROR)
        list(APPEND BOOST_LOCALE_WARNING_OPTIONS /WX)
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(BOOST_LOCALE_WARNING_OPTIONS -Wall -Wextra -Wno-error=deprecated-declarations)
    if(BOOST_LOCALE_WERROR)
        list(APPEND BOOST_LOCALE_WARNING_OPTIONS -Werror)
    endif()
elseif(NOT DEFINED BOOST_LOCALE_WARNING_OPTIONS)
    set(BOOST_LOCALE_WARNING_OPTIONS "")
endif()
target_compile_options(boost_locale PRIVATE ${BOOST_LOCALE_WARNING_OPTIONS})

option(BOOST_LOCALE_ENABLE_CXX11_CHAR_TYPES "Enable C++11 char16/char32 type support (experimental)" OFF)
if(BOOST_LOCALE_ENABLE_CXX11_CHAR_TYPES)
    target_compile_definitions(boost_locale PUBLIC BOOST_LOCALE_ENABLE_CHAR16_T BOOST_LOCALE_ENABLE_CHAR32_T)
endif()

# Testing

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)
  add_subdirectory(examples)

endif()

=== libs/mysql/CMakeLists.txt ===
#
# Copyright (c) 2019-2023 Ruben Perez Hidalgo (rubenperez038 at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#

cmake_minimum_required(VERSION 3.8...3.22)

# Project
project(boost_mysql VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

# Determine if we're the top-level project. Used for extra functionality and Boost dependency management.
# We've got the following use cases:
#  1. We're building the superproject, and it has called add_subdirectory() on us. BOOST_SUPERPROJECT_VERSION defined.
#  2. Someone's calling add_subdirectory() on us and doesn't want us to find_package Boost, e.g. the cmake subdir test.
#  3. We're the main project and we want to use an installed version of Boost (e.g. normal development)
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(BOOST_MYSQL_IS_ROOT ON)
else()
    set(BOOST_MYSQL_IS_ROOT OFF)
endif()

# Library
add_library(boost_mysql INTERFACE)
add_library(Boost::mysql ALIAS boost_mysql)

# Dependencies
if (BOOST_MYSQL_IS_ROOT)
    # If we're the root project, error if a dependency is not found
    find_package(Boost ${BOOST_MYSQL_VERSION} REQUIRED COMPONENTS headers system)
    find_package(Threads REQUIRED)
    find_package(OpenSSL REQUIRED)
    target_link_libraries(
        boost_mysql
        INTERFACE
        Boost::headers
        Boost::system
        Threads::Threads
        OpenSSL::Crypto
        OpenSSL::SSL
    )
else()
    # If we're in the superproject or called from add_subdirectory,
    # Boost dependencies should be already available.
    # If other dependencies are not found, we bail out
    find_package(Threads)
    if(NOT Threads_FOUND)
        message(STATUS "Boost.MySQL has been disabled, because the required package Threads hasn't been found")
        return()
    endif()
    find_package(OpenSSL)
    if(NOT OpenSSL_FOUND)
        message(STATUS "Boost.MySQL has been disabled, because the required package OpenSSL hasn't been found")
        return()
    endif()

    # This is generated by boostdep
    target_link_libraries(
        boost_mysql
        INTERFACE
        Boost::asio
        Boost::assert
        Boost::config
        Boost::core
        Boost::describe
        Boost::mp11
        Boost::system
        Boost::throw_exception
        Boost::variant2
        Boost::endian
        Boost::lexical_cast
        Threads::Threads
        OpenSSL::Crypto
        OpenSSL::SSL
    )
endif()

# Includes & features
if (BOOST_MYSQL_IS_ROOT)
    target_include_directories(boost_mysql SYSTEM INTERFACE include)
else()
    target_include_directories(boost_mysql INTERFACE include)
endif()
target_compile_features(boost_mysql INTERFACE cxx_std_11)

# If we are the top-level project, enable CTest and some extra options used in CI
if(BOOST_MYSQL_IS_ROOT)
    include(CTest)

    # Don't run integration testing unless explicitly requested
    option(BOOST_MYSQL_INTEGRATION_TESTS OFF "Whether to build and run integration tests or not")
    mark_as_advanced(BOOST_MYSQL_INTEGRATION_TESTS)

    # Valgrind tests and Valgrind-friendly code (e.g. mark SSL buffers as initialized)
    option(BOOST_MYSQL_VALGRIND_TESTS OFF "Whether to run Valgrind tests or not (requires Valgrind)")
    mark_as_advanced(BOOST_MYSQL_VALGRIND_TESTS)
    
    # Build with coverage
    option(BOOST_MYSQL_COVERAGE OFF "Whether to build using coverage")
    mark_as_advanced(BOOST_MYSQL_COVERAGE)
endif()

# Examples and tests
if(BUILD_TESTING)
    # Contains some functions to share code between examples and tests
    include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/test_utils.cmake)

    # Custom target tests; required by the Boost superproject
    if(NOT TARGET tests)
        add_custom_target(tests)
    endif()

    # All examples require a real server to run
    add_subdirectory(test)
    if (BOOST_MYSQL_INTEGRATION_TESTS)
        add_subdirectory(example)
    endif()

endif()

=== libs/random/CMakeLists.txt ===
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_random VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_random
  src/random_device.cpp
)

add_library(Boost::random ALIAS boost_random)

target_include_directories(boost_random PUBLIC include)

target_link_libraries(boost_random
  PUBLIC
    Boost::array
    Boost::assert
    Boost::config
    Boost::core
    Boost::dynamic_bitset
    Boost::integer
    Boost::io
    Boost::range
    Boost::static_assert
    Boost::system
    Boost::throw_exception
    Boost::type_traits
    Boost::utility
)

target_compile_definitions(boost_random
  PUBLIC BOOST_RANDOM_NO_LIB
  # Source files already define BOOST_RANDOM_SOURCE
  # PRIVATE BOOST_RANDOM_SOURCE
)

if(BUILD_SHARED_LIBS)
  target_compile_definitions(boost_random PUBLIC BOOST_RANDOM_DYN_LINK)
else()
  target_compile_definitions(boost_random PUBLIC BOOST_RANDOM_STATIC_LINK)
endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/spirit/CMakeLists.txt ===
# Generated by `boostdep --cmake spirit`
# Copyright 2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_spirit VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_spirit INTERFACE)
add_library(Boost::spirit ALIAS boost_spirit)

target_include_directories(boost_spirit INTERFACE include)

target_link_libraries(boost_spirit
  INTERFACE
    Boost::array
    Boost::assert
    Boost::config
    Boost::core
    Boost::endian
    Boost::function
    Boost::function_types
    Boost::fusion
    Boost::integer
    Boost::io
    Boost::iterator
    Boost::move
    Boost::mpl
    Boost::optional
    Boost::phoenix
    Boost::pool
    Boost::preprocessor
    Boost::proto
    Boost::range
    Boost::smart_ptr
    Boost::static_assert
    Boost::thread
    Boost::throw_exception
    Boost::type_traits
    Boost::typeof
    Boost::unordered
    Boost::utility
    Boost::variant
)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()

=== libs/stl_interfaces/CMakeLists.txt ===
if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

# Generated by `boostdep --cmake stl_interfaces`
# Copyright 2020, 2021 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.8...3.20)

project(boost_stl_interfaces VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_stl_interfaces INTERFACE)
add_library(Boost::stl_interfaces ALIAS boost_stl_interfaces)

target_include_directories(boost_stl_interfaces INTERFACE include)

target_link_libraries(boost_stl_interfaces
  INTERFACE
    Boost::assert
    Boost::config
)

target_compile_features(boost_stl_interfaces INTERFACE cxx_std_14)

else()

# Copyright (C) 2019 T. Zachary Laine
#
# Distributed under the Boost Software License, Version 1.0. (See
# accompanying file LICENSE_1_0.txt or copy at
# http://www.boost.org/LICENSE_1_0.txt)
cmake_minimum_required(VERSION 3.5)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

project(stl_interfaces)

################################################## 
# C++ standard version selection
################################################## 
set(CXX_STD 14 CACHE STRING "Set to X to enable C++X builds.")
message("-- Using -std=c++${CXX_STD}")

if (MSVC)
  add_compile_options(/Zc:__cplusplus)
endif()

##################################################
# Sanitizers
##################################################
set(USE_ASAN false CACHE BOOL "Set to true to enable -fsanitize=address when building tests.") 
set(USE_UBSAN false CACHE BOOL "Set to true to enable -fsanitize=undefined when building tests.")
if (USE_ASAN AND USE_UBSAN)
    message(FATAL_ERROR "USE_ASAN and USE_UBSAN must not be enabled at the same time")
elseif (USE_ASAN)
    set(compile_flags -fsanitize=address)
    set(link_flags -fsanitize=address)
    message("-- Using -fsanitize=address") 
elseif (USE_UBSAN)
    set(compile_flags -fsanitize=undefined)
    set(link_flags -fsanitize=undefined)
    message("-- Using -fsanitize=undefined")
endif()


##################################################
# Code coverage
##################################################
if (UNIX)
    set(BUILD_COVERAGE false CACHE BOOL "Set to true to enable code coverage when building tests.  Only Linux and Mac are supported.")
    if (BUILD_COVERAGE)
        message("-- Building for code coverage; disabling any sanitizers")
        if (APPLE)
            set(compile_flags -fprofile-arcs -ftest-coverage)
            set(CMAKE_BUILD_TYPE Debug)
            set(link_flags --coverage)
        else ()
            set(compile_flags --coverage)
            set(CMAKE_BUILD_TYPE Debug)
            set(link_flags --coverage)
        endif ()
    endif ()
endif ()

##################################################
# Dependencies
##################################################
set(boost_components)
include(dependencies)

##################################################
# stl_interfaces library
##################################################
add_library(stl_interfaces INTERFACE)

target_include_directories(stl_interfaces INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include)
target_link_libraries(stl_interfaces INTERFACE boost)
if (link_flags)
    target_link_libraries(stl_interfaces INTERFACE ${link_flags})
    target_compile_options(stl_interfaces INTERFACE ${compile_flags})
endif ()
if (NOT MSVC)
    target_compile_options(stl_interfaces INTERFACE -Wall)
endif ()


add_subdirectory(test)
add_subdirectory(example)

endif()

=== debian/changelog ===
boost1.83 (1.83.0-5ubuntu1) questing; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2
    - d/rules: keep BUILD_LONG_DOUBLE on for ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 09 Sep 2025 10:43:07 +0200

boost1.83 (1.83.0-5) unstable; urgency=medium

  * [ebf48a2] Fix build on clang-19. (Closes: #1097629)

 -- Anton Gladky <gladk@debian.org>  Sat, 06 Sep 2025 20:31:01 +0200

boost1.83 (1.83.0-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:21:22 +0200

boost1.83 (1.83.0-4.2ubuntu3) questing; urgency=medium

  * Build stacktrace on i386.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 28 May 2025 11:21:27 +0200

boost1.83 (1.83.0-4.2ubuntu2) questing; urgency=medium

  * d/rules: keep BUILD_LONG_DOUBLE on for ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 05 May 2025 16:03:37 +0200

boost1.83 (1.83.0-4.2ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Tue, 25 Mar 2025 14:26:18 +0100

boost1.83 (1.83.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Another fix for numpy 2.0. Closes: #1099671.
    - Compare pointers directly instead of using PyArray_EquivTypes
  * Enable context library on ppc64. Closes: #1071542.
  * Use static const for next/prior from C++17. Closes: #1093824.

 -- Matthias Klose <doko@debian.org>  Tue, 25 Mar 2025 14:04:56 +0100

boost1.83 (1.83.0-4.1ubuntu2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 16:55:46 +0000

boost1.83 (1.83.0-4.1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Feb 2025 17:07:26 +0100

boost1.83 (1.83.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with NumPy 2.x. Closes: #1094654.

 -- Matthias Klose <doko@debian.org>  Fri, 14 Feb 2025 16:45:31 +0100

boost1.83 (1.83.0-4ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 20:29:18 +0100

boost1.83 (1.83.0-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Dec 2024 18:46:02 +0100

boost1.83 (1.83.0-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * control: Add hurd-amd64 for context, coroutine, fiber packages.
  * [a2dab5e] control: Add hurd-amd64 for context, coroutine, fiber packages.

  [ Heinrich Schuchardt ]
  * [62a479e] Fix autopkgtests fail on armhf. (Closes: #1079106)

  [ Anton Gladky ]
  * [49b0d7f] Update the minimal cmake version for autopkgtest to 3.18.
              (Closes: #1087853)

 -- Anton Gladky <gladk@debian.org>  Sat, 07 Dec 2024 20:39:34 +0100

boost1.83 (1.83.0-3.2ubuntu4) plucky; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 30 Nov 2024 07:13:58 +0100

boost1.83 (1.83.0-3.2ubuntu3) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 10:53:57 +0100

boost1.83 (1.83.0-3.2ubuntu2) oracular; urgency=medium

  [ Heinrich Schuchardt ]
  * Disable OpenMPI related tests on armhf (LP: #2076225)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Sep 2024 00:10:13 +0200

boost1.83 (1.83.0-3.2ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Sep 2024 20:15:17 +0200

boost1.83 (1.83.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Additional workaround for broken architecture detection under x32
    (Closes: #1079358)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 22 Aug 2024 14:09:24 +0200

boost1.83 (1.83.0-3.1ubuntu2) oracular; urgency=medium

  * Disable OpenMPI related tests on armhf (LP: #2076225)

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Mon, 12 Aug 2024 09:57:42 +0200

boost1.83 (1.83.0-3.1ubuntu1) oracular; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.
    - Apply distro CXXFLAGS when boostrapping b2

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 01 Aug 2024 13:09:23 +0200

boost1.83 (1.83.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "Boost.Signals2 causes FTBFS", cherry-picking upstream patch
   (Closes: #1056100)
  * Fix "autopkgtest regression with CMake 3.30+", enforcing the new CMP0167
    policy. (Closes: #1076426)

 -- Tobias Frost <tobi@debian.org>  Tue, 30 Jul 2024 09:09:13 +0200

boost1.83 (1.83.0-3ubuntu2) oracular; urgency=medium

  * Apply distro CXXFLAGS when boostrapping b2 (LP: #2073861)

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 23 Jul 2024 11:08:40 +0200

boost1.83 (1.83.0-3ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Drop unused packages on i386.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 May 2024 08:02:39 +0200

boost1.83 (1.83.0-3) unstable; urgency=medium

  * [4b317f3] Add upstream fix for dogecoin. (Closes: #1059133)

 -- Anton Gladky <gladk@debian.org>  Mon, 27 May 2024 06:59:36 +0200

boost1.83 (1.83.0-2.1ubuntu3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:23:37 +0000



=== debian/control ===
Source: boost1.83
Homepage: https://www.boost.org/
Section: libs
Priority: optional
Maintainer: Debian Boost Team <team+boost@tracker.debian.org>
Uploaders:
 Giovanni Mascellani <gio@debian.org>,
 Anton Gladky <gladk@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 12), dpkg-dev (>= 1.16.1~), dctrl-tools, chrpath,
 zlib1g-dev, libbz2-dev, liblzma-dev, libzstd-dev, libicu-dev (>= 63.1), mpi-default-dev [!i386],
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen,
 docbook-xsl, docbook-xml, texlive-latex-base, ghostscript,
 dh-python,
 g++ (>= 4:5-0),
 python3, python3-all-dev (>= 3.1), python3-numpy [!i386]
Build-Depends-Indep: graphviz
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: https://salsa.debian.org/debian/boost
Vcs-Git: https://salsa.debian.org/debian/boost.git
Standards-Version: 4.6.2

Package: libboost1.83-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-${gxx:major}-dev
Suggests: libboost1.83-doc,
 libboost-atomic1.83-dev,
 libboost-chrono1.83-dev,
 libboost-container1.83-dev [!i386],
 libboost-context1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-contract1.83-dev [!i386],
 libboost-coroutine1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.83-dev,
 libboost-exception1.83-dev [!i386],
 libboost-fiber1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.83-dev,
 libboost-graph-parallel1.83-dev [!i386],
 libboost-graph1.83-dev [!i386],
 libboost-iostreams1.83-dev,
 libboost-json1.83-dev [!i386],
 libboost-locale1.83-dev [!i386],
 libboost-log1.83-dev [!i386],
 libboost-math1.83-dev [!i386],
 libboost-mpi-python1.83-dev [!i386],
 libboost-mpi1.83-dev [!i386],
 libboost-nowide1.83-dev [!i386],
 libboost-numpy1.83-dev [!i386],
 libboost-program-options1.83-dev,
 libboost-python1.83-dev [!i386],
 libboost-random1.83-dev [!i386],
 libboost-regex1.83-dev,
 libboost-serialization1.83-dev,
 libboost-stacktrace1.83-dev,
 libboost-system1.83-dev,
 libboost-test1.83-dev,
 libboost-thread1.83-dev,
 libboost-timer1.83-dev [!i386],
 libboost-type-erasure1.83-dev [!i386],
 libboost-url1.83-dev [!i386],
 libboost-wave1.83-dev [!i386],
 libboost1.83-tools-dev [!i386],
 libmpfrc++-dev,
 libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev, libboost1.62-dev, libboost1.63-dev, libboost1.65-dev, libboost1.67-dev, libboost1.70-dev, libboost1.71-dev, libboost1.74-dev, libboost1.80-dev, libboost1.81-dev
Breaks: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Replaces: libleatherman-dev (<< 1.12.1+dfsg-1.1~)
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.83-tools-dev
Architecture: amd64 arm64 armhf s390x ppc64el riscv64
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev, libboost1.62-tools-dev, libboost1.63-tools-dev, libboost1.65-tools-dev, libboost1.67-tools-dev, libboost1.70-tools-dev, libboost1.71-tools-dev, libboost1.74-tools-dev, libboost1.80-tools-dev, libboost1.81-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.83-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.83-dev,
 libboost1.83-tools-dev [!i386],
 libboost-atomic1.83-dev,
 libboost-chrono1.83-dev,
 libboost-container1.83-dev [!i386],
 libboost-context1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-coroutine1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-date-time1.83-dev,
 libboost-exception1.83-dev [!i386],
 libboost-fiber1.83-dev [hurd-i386 kfreebsd-i386 amd64 hurd-amd64 kfreebsd-amd64 armel armhf arm64 loong64 mips mipsel mips64el powerpc ppc64el riscv64 s390x],
 libboost-filesystem1.83-dev,
 libboost-graph-parallel1.83-dev [!i386],
 libboost-graph1.83-dev [!i386],
 libboost-iostreams1.83-dev,
 libboost-json1.83-dev [!i386],
 libboost-locale1.83-dev [!i386],
 libboost-log1.83-dev [!i386],
 libboost-math1.83-dev [!i386],
 libboost-mpi-python1.83-dev [!i386],
 libboost-mpi1.83-dev [!i386],
 libboost-nowide1.83-dev [!i386],
 libboost-numpy1.83-dev [!i386],
 libboost-program-options1.83-dev [!i386],
 libboost-python1.83-dev [!i386],
 libboost-random1.83-dev [!i386],
 libboost-regex1.83-dev,
 libboost-serialization1.83-dev,
 libboost-stacktrace1.83-dev,
 libboost-system1.83-dev,
 libboost-test1.83-dev,
 libboost-thread1.83-dev,
 libboost-timer1.83-dev [!i386],
 libboost-type-erasure1.83-dev [!i386],
 libboost-url1.83-dev [!i386],
 libboost-wave1.83-dev [!i386]
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.83-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-mathjax
Suggests: libboost1.83-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc, libboost1.62-doc, libboost1.63-doc, libboost1.65-doc, libboost1.67-doc, libboost1.70-doc, libboost1.71-doc, libboost1.74-doc, libboost1.80-doc, libboost1.81-doc
Description: Boost.org libraries documentation placeholder
 This package originally provided documentation, but has since fallen
 into disrepair and presently provides no documentation.  Please
 use documentation at www.boost.org.

Package: libboost-atomic1.83.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.83-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.83-dev (= ${binary:Version}),
 libboost-atomic1.83.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev, libboost-atomic1.62-dev, libboost-atomic1.63-dev, libboost-atomic1.65-dev, libboost-atomic1.67-dev, libboost-atomic1.70-dev, libboost-atomic1.71-dev, libboost-atomic1.74-dev, libboost-atomic1.80-dev, libboost-atomic1.81-dev

Package: libboost-chrono1.83.0t64
Provides: ${t64:Provides}
Replaces: libboost-chrono1.83.0
Breaks: libboost-chrono1.83.0 (<< ${source:Version})
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular

=== debian/rules ===
#! /usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq ($(DEB_BUILD_ARCH), i386)
boost_libs := atomic chrono date-time filesystem iostreams \
              regex serialization stacktrace system test thread
JAM_WITHOUT += --without-container --without-contract --without-exception \
               --without-graph --without-graph_parallel \
               --without-locale --without-log --without-math --without-mpi --without-nowide \
               --without-program_options --without-random \
               --without-timer --without-type_erasure \
               --without-wave --without-json --without-url
else
# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono container contract date-time exception filesystem	\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python nowide program-options python random regex	\
              serialization stacktrace system test thread timer \
              type-erasure wave json url
endif

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
ifeq ($(DEB_BUILD_ARCH), m68k)
# See https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=962072
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_basic
else
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_backtrace stacktrace_basic
endif
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

pyversions = $(shell py3versions -rv)
pyverids = $(subst .,,$(pyversions))

# These are special cases for suffixes.
boost_suffixes_python := $(pyverids)
boost_suffixes_numpy := $(pyverids)
boost_suffixes_mpi-python := $(pyverids)

# Files that are generated by filtering a template
filtered_files =

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

version_full := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
version_upstream := $(shell echo $(version_full) | cut -d'-' -f1 | cut -d '+' -f1)
version_major := $(shell echo $(version_upstream) | cut -d'.' -f1,2)

PKGVERSION = $(version_major)
SOVERSION = $(version_upstream)

icuabi = $(shell apt show libicu-dev 2>/dev/null | sed -n 's/Depends: .*libicu\([0-9]*\) .*/\1/p')
regexicuabi = libboost-regex$(SOVERSION)-icu$(icuabi)

# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component
boost_suffixes = $(if $(boost_suffixes_$(1)), $(boost_suffixes_$(1)),"")

# Helpers to make basic and decorated library names
# Input: library, suffix
# Return: base library filename for short or full name
mk_base_name = usr/lib/$(DEB_HOST_MULTIARCH)/libboost_$(subst -,_,$(1))$(2)
mk_cmake_name = usr/lib/$(DEB_HOST_MULTIARCH)/cmake/boost_$(subst -,_,$(1))-$(SOVERSION)/

t64_suffix_chrono = t64
# Input: component
# Return: package name for shared library or development
mk_pkg_lib = libboost-$(1)$(SOVERSION)$(t64_suffix_$(1))
mk_pkg_dev = libboost-$(1)$(PKGVERSION)-dev
# Helpers to generate debhelper input filenames.
# Input: component
# Return: prefix to debhelper filenames
mk_deb_lib = debian/$(call mk_pkg_lib,$(1))
mk_deb_dev = debian/$(call mk_pkg_dev,$(1))

# Helpers that update debhelper .install or .links files
# Input: component, library, suffix
# Output: none
mk_so_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).so.$(SOVERSION) >> $(call mk_deb_lib,$(1)).install)
mk_a_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).a >> $(call mk_deb_dev,$(1)).install)
mk_ln_files = $(shell echo $(call mk_base_name,$(2),$(3)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3)).so >> $(call mk_deb_dev,$(1)).links)
mk_cmake_files = $(shell echo debian/tmp/$(call mk_cmake_name,$(2),$(3)) >> $(call mk_deb_dev,$(1)).install)

# Specify the type of files/links to install.
# Special cases first, then general rule
boost_filetypes_exception = a cmake
boost_filetypes_test_exec_monitor = a cmake
boost_filetypes = $(if $(boost_filetypes_$(1)), $(boost_filetypes_$(1)),a so ln cmake)

# Function that updates debhelper files for a given library
# Input: component, library, suffix
# Output: none
mk_files = $(foreach fn,$(call boost_filetypes,$(2)),$(call mk_$(fn)_files,$(1),$(2),$(3)))

# helpers to make and install lintian override files

# Input: package, override
add_override = echo $(1): $(2) >> debian/$(1).lintian-overrides;

# Input: override
add_dev_override = $(call add_override,libboost$(PKGVERSION)-dev,$(1))
add_doc_override = $(call add_override,libboost$(PKGVERSION)-doc,$(1))

# Input: component, lintian-warning
add_lib_override = $(call add_override,$(call mk_pkg_lib,$(1)),$(2))
add_libdev_override = $(call add_override,$(call mk_pkg_dev,$(1)),$(2))

# Input: package-name-base, versioned-package-name
cp_debhelper = set -e ; for s in doc-base examples postinst prerm README.Debian; do \
	if test -f debian/$(1).$$s; then cp -f debian/$(1).$$s debian/$(2).$$s; fi; done

# Function that updates debhelper files for all libraries shipped.
mk_debhelper_files = \
	$(call add_dev_override,extra-license-file) \
	$(call add_doc_override,extra-license-file) \
	$(foreach l, $(boost_libs), \
		echo "making debhelper files for $(l)..."; \
		$(call add_lib_override,$(l),package-name-doesnt-match-sonames) \
		$(foreach ll, $(call boost_lib,$(l)), \
			$(foreach suf, $(call boost_suffixes,$(l)), \
				$(call mk_files,$(l),$(ll),$(suf)) \
			) \
		) \
	)

TOOLSET_CONFIG = 'using gcc : : : <compileflags>"$(CPPFLAGS)" <cflags>"$(CFLAGS)" <cxxflags>"$(CXXFLAGS) -Wno-unused-local-typedefs" <linkflags>"$(LDFLAGS)" ;'
BUILD_CONTEXT = yes
BUILD_LONG_DOUBLE = yes
BUILD_NUMPY = yes

ifeq ($(DEB_VENDOR)-$(DEB_HOST_ARCH),Ubuntu-i386)
BUILD_CONTEXT = no
BUILD_NUMPY = no
endif

# Disable long double on some architectures
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arm armel armhf arm64 hppa mips mipsel sh4 powerpc ppc64))
BUILD_LONG_DOUBLE = no
endif

# Disable context, coroutine, fiber on some architectures
ifneq (,$(filter $(DEB_HOST_ARCH), alpha hppa ia64 m68k mips64 powerpcspe s390 sh4 sparc sparc64 x32))
BUILD_CONTEXT = no
endif

ifeq ($(DEB_BUILD_ARCH), arm64)
JAM_OPT += pch=off
endif

# if we're building with context, coroutine, fiber, add the libraries to the list
ifeq ($(BUILD_CONTEXT), yes)
boost_libs += context coroutine fiber
else
JAM_WITHOUT += --without-context --without-coroutine --without-fiber
endif

# if we're building with long double, add the libraries to the list
ifeq ($(BUILD_LONG_DOUBLE), yes)
boost_lib_math += $(boost_lib_math_long_double)
else
JAM_OPT += --disable-long-double
endif

# if we're building with numpy, add the libraries to the list
ifeq ($(BUILD_NUMPY), yes)
boost_libs += numpy
endif

exampledir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/examples
b2 = $(CURDIR)/b2
bbv2dir = $(CURDIR)/tools/build

# With --ignore-site-config, can probably drop Build-Conflicts on boost-build.
JAM = $(b2) $(JOBS) -q -d2 $(JAM_OPT) --layout=system --ignore-site-config --user-config=$(CURDIR)/user-config.jam debug-symbols=on
JAM_DOC = $(b2) $(JOBS) -q -d2 --ignore-site-config --user-config=$(CURDIR)/user-config-doc.jam --enable-index

%:
	dh $@ --with python3

override_dh_auto_configure: user-config.jam make-debhelper
